.align 64
.globl AES_192_KE_w_avx
AES_192_KE_w_avx:

   movl   $12, 240(%rsi)
   vmovdqu (%rdi), %xmm1
   vmovdqu 16(%rdi), %xmm3				
   vmovdqa %xmm1, (%rsi)				
   vmovdqa %xmm3, %xmm5					

   vaeskeygenassist $0x1, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vshufpd $0, %xmm1, %xmm5, %xmm5
   vmovdqa %xmm5, 16(%rsi)
   vshufpd $1, %xmm3, %xmm1, %xmm6
   vmovdqa %xmm6, 32(%rsi)

   vaeskeygenassist $0x2, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vmovdqa %xmm1, 48(%rsi)
   vmovdqa %xmm3, %xmm5

   vaeskeygenassist $0x4, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vshufpd $0, %xmm1, %xmm5, %xmm5
   vmovdqa %xmm5, 64(%rsi)
   vshufpd $1, %xmm3, %xmm1, %xmm6
   vmovdqa %xmm6, 80(%rsi)

   vaeskeygenassist $0x8, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vmovdqa %xmm1, 96(%rsi)
   vmovdqa %xmm3, %xmm5

   vaeskeygenassist $0x10, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vshufpd $0, %xmm1, %xmm5, %xmm5
   vmovdqa %xmm5, 112(%rsi)
   vshufpd $1, %xmm3, %xmm1, %xmm6
   vmovdqa %xmm6, 128(%rsi)

   vaeskeygenassist $0x20, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vmovdqa %xmm1, 144(%rsi)
   vmovdqa %xmm3, %xmm5

   vaeskeygenassist $0x40, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vshufpd $0, %xmm1, %xmm5, %xmm5
   vmovdqa %xmm5, 160(%rsi)
   vshufpd $1, %xmm3, %xmm1, %xmm6
   vmovdqa %xmm6, 176(%rsi)

   vaeskeygenassist $0x80, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   vmovdqa %xmm1, 192(%rsi)

   ret

.align 64
PREPARE_ROUNDKEY_192: 
   vpshufd $0x55, %xmm2, %xmm2 
   vpslldq $4, %xmm1, %xmm4
   vpxor   %xmm4, %xmm1, %xmm1
   vpslldq $4, %xmm4, %xmm4
   vpxor   %xmm4, %xmm1, %xmm1
   vpslldq $4, %xmm4, %xmm4
   vpxor   %xmm4, %xmm1, %xmm1
   vpxor   %xmm2, %xmm1, %xmm1
   vpshufd $0xff, %xmm1, %xmm2
   vpslldq $4, %xmm3, %xmm4
   vpxor   %xmm4, %xmm3, %xmm3
   vpxor   %xmm2, %xmm3, %xmm3
   ret
